# JOB Info

A tiny script to compute query properties of JOB queries.

## Description

This repository provides a script `job-info.py` that computes properties of the query graphs of the queries in the [*join order benchmark* (JOB)](https://github.com/gregrahn/join-order-benchmark).

## Usage

First, clone the JOB repository with

```bash
$ git submodule update # downloads the JOB repo
```

Then, run the script on JOB

```bash
$ python job-info.py job/ # specify the path to JOB
```

The script uses [EasyGraph](https://easy-graph.github.io/docs/index.html) to construct the query graph of each JOB query.
The joins are extracted from the query via simple pattern matching.
The edges of the query graph are then constructed from these extracted joins.
The script computes interesting graph properties *density* and *skew* and writes them -- together with other graph information -- to stdout.

### Graph Visualization

The query graphs can be visualized by rendering the graph with graphviz (using the circo engine) to a PDF document.
Use flag `--show` to enable graph visualization.
